/*
 File: cweave_fsm_sdc.h
 Date and Time: Fri Jan 30 18:55:07 2015 
*/
#ifndef __cweave_fsm_sdc_h__
#define __cweave_fsm_sdc_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "o2_externs.h"
  
// monolithic grammar: no thread
extern yacco2::State S1_Ccweave_fsm_sdc;
namespace NS_cweave_fsm_sdc {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[3];
};
class Ccweave_fsm_sdc: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rweave_fsm_sdc_ = 569//start_of_rule_list + 0
    ,rhs1_Rweave_fsm_sdc_ = 1
   ,R_Rdirectives_ = 570//start_of_rule_list + 2
    ,rhs1_Rdirectives_ = 2
    ,rhs2_Rdirectives_ = 3
   ,R_Rdirective_ = 571//start_of_rule_list + 4
    ,rhs1_Rdirective_ = 4
    ,rhs2_Rdirective_ = 5
    ,rhs3_Rdirective_ = 6
    ,rhs4_Rdirective_ = 7
    ,rhs5_Rdirective_ = 8
    ,rhs6_Rdirective_ = 9
    ,rhs7_Rdirective_ = 10
    ,rhs8_Rdirective_ = 11
    ,rhs9_Rdirective_ = 12
    ,rhs10_Rdirective_ = 13
  };
  //no of la sets = 2
  //no of states = 15
  Ccweave_fsm_sdc();
  ~Ccweave_fsm_sdc();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[14];
  
    public:
    std::ofstream* cweave_file_;
	T_fsm_phrase* fsm_phrase_;
	void initialize
		(std::ofstream* Cweave_file
		,T_fsm_phrase* Fsm_phrase);
    void output_sr_sdcode(const char* Directive);
    void output_sr_sdcode_title(const char* Directive);
    void wrt_directive(const char* Directive,T_syntax_code* Sdc);
  
 };
struct Rweave_fsm_sdc;
struct Rdirectives;
struct Rdirective;
struct Rweave_fsm_sdc:public yacco2::CAbs_lr1_sym {
  Rweave_fsm_sdc(yacco2::Parser* P);
  public:
};

struct Rdirectives:public yacco2::CAbs_lr1_sym {
  Rdirectives(yacco2::Parser* P);
  public:
};

struct Rdirective:public yacco2::CAbs_lr1_sym {
  Rdirective(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
  void sr9();
  void sr10();
};

} // end of namespace

#endif
